Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -4553,7 +4519,7 @@
        INTEGER(iwp) ::  k_pp      !< k+2 index in disretization, can be modified to avoid segmentation faults
        INTEGER(iwp) ::  k_ppp     !< k+3 index in disretization, can be modified to avoid segmentation faults
-       INTEGER(iwp) ::  nzb_max_l !< index indicating upper bound for order degradation of horizontal advection terms 
-       INTEGER(iwp) ::  tn = 0    !< number of OpenMP thread
-       
+       INTEGER(iwp) ::  nzb_max_l !< index indicating upper bound for order degradation of horizontal advection terms
+       INTEGER(iwp) ::  tn = 0    !< number of OpenMP thread (is always zero here)
+
        REAL(wp)    ::  ibit0 !< flag indicating 1st-order scheme along x-direction
        REAL(wp)    ::  ibit1 !< flag indicating 3rd-order scheme along x-direction
@@ -4579,112 +4545,22 @@
        REAL(wp)    ::  flux_d !< 6th-order flux at grid box bottom
        REAL(wp)    ::  gu     !< Galilei-transformation velocity along x
-       REAL(wp)    ::  gv     !< Galilei-transformation velocity along y 
-       REAL(wp)    ::  v_comp !< advection velocity along y
-#ifdef _OPENACC
+       REAL(wp)    ::  gv     !< Galilei-transformation velocity along y
+       REAL(wp)    ::  u_comp_l !<
        REAL(wp)    ::  v_comp_s !< advection velocity along y
-#endif
-       REAL(wp)    ::  w_comp !< advection velocity along z
-       
-       REAL(wp)    :: diss_s  !< discretized artificial dissipation at southward-side of the grid box
-       REAL(wp)    :: flux_s  !< discretized 6th-order flux at southward-side of the grid box
-#ifndef _OPENACC
-       REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_diss_y_local_u !< discretized artificial dissipation at southward-side of the grid box
-       REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_flux_y_local_u !< discretized 6th-order flux at southward-side of the grid box
-#endif
-       
-       REAL(wp)    :: diss_l  !< discretized artificial dissipation at leftward-side of the grid box
-       REAL(wp)    :: flux_l  !< discretized 6th-order flux at leftward-side of the grid box
-#ifndef _OPENACC
-       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local_u !< discretized artificial dissipation at leftward-side of the grid box
-       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_flux_x_local_u !< discretized 6th-order flux at leftward-side of the grid box
-#endif
-       
-       REAL(wp) ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
-       REAL(wp) ::  diss_r !< discretized artificial dissipation at leftward-side of the grid box
-       REAL(wp) ::  diss_t !< discretized artificial dissipation at top of the grid box
-       REAL(wp) ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
-       REAL(wp) ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
-       REAL(wp) ::  flux_t !< discretized 6th-order flux at top of the grid box
-       REAL(wp) ::  u_comp !< advection velocity along x
-#ifdef _OPENACC
-       REAL(wp)    ::  u_comp_l !<
-#endif
-!
-!--    Set local version of nzb_max. At non-cyclic boundaries the order of the 
-!--    advection need to be degraded near the boundary. Please note, in contrast
-!--    to the cache-optimized routines, nzb_max_l is set constantly for the 
-!--    entire subdomain, in order to avoid unsymmetric loops which might be 
-!--    an issue for GPUs.
-       IF( bc_dirichlet_l  .OR.  bc_radiation_l  .OR.                          &
-           bc_dirichlet_r  .OR.  bc_radiation_r  .OR.                          &
-           bc_dirichlet_s  .OR.  bc_radiation_s  .OR.                          &
-           bc_dirichlet_n  .OR.  bc_radiation_n )  THEN
-          nzb_max_l = nzt
-       ELSE
-          nzb_max_l = nzb_max
-       END IF 
- 
+
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  diss_t !< discretized artificial dissipation at top of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  flux_t !< discretized 6th-order flux at top of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  u_comp !< advection velocity along x
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  v_comp !< advection velocity along y
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  w_comp !< advection velocity along z
+
+       CALL cpu_log( log_point_s(68), 'advec_u_ws', 'start' )
+
        gu = 2.0_wp * u_gtrans
        gv = 2.0_wp * v_gtrans
-
-#ifndef _OPENACC
-!
-!--    Compute the fluxes for the whole left boundary of the processor domain.
-       i = nxlu
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzb_max_l
-
-             ibit2 = REAL( IBITS(advc_flags_m(k,j,i-1),2,1), KIND = wp )
-             ibit1 = REAL( IBITS(advc_flags_m(k,j,i-1),1,1), KIND = wp )
-             ibit0 = REAL( IBITS(advc_flags_m(k,j,i-1),0,1), KIND = wp )
-
-             u_comp                   = u(k,j,i) + u(k,j,i-1) - gu
-             swap_flux_x_local_u(k,j) = u_comp * (                             &
-                                       ( 37.0_wp * ibit2 * adv_mom_5           &
-                                    +     7.0_wp * ibit1 * adv_mom_3           &
-                                    +              ibit0 * adv_mom_1           &
-                                       ) *                                     &
-                                     ( u(k,j,i)   + u(k,j,i-1) )               &
-                                -      (  8.0_wp * ibit2 * adv_mom_5           &
-                                    +              ibit1 * adv_mom_3           &
-                                       ) *                                     &
-                                     ( u(k,j,i+1) + u(k,j,i-2) )               &
-                                +      (           ibit2 * adv_mom_5           &
-                                       ) *                                     &
-                                     ( u(k,j,i+2) + u(k,j,i-3) )               &
-                                                   )
-
-              swap_diss_x_local_u(k,j) = - ABS( u_comp ) * (                   &
-                                       ( 10.0_wp * ibit2 * adv_mom_5           &
-                                    +     3.0_wp * ibit1 * adv_mom_3           &
-                                    +              ibit0 * adv_mom_1          &
-                                       ) *                                     &
-                                     ( u(k,j,i)   - u(k,j,i-1) )               &
-                                -      (  5.0_wp * ibit2 * adv_mom_5           &
-                                    +              ibit1 * adv_mom_3           &
-                                       ) *                                     &
-                                     ( u(k,j,i+1) - u(k,j,i-2) )               &
-                                +      (           ibit2 * adv_mom_5           &
-                                       ) *                                     &
-                                     ( u(k,j,i+2) - u(k,j,i-3) )               &
-                                                             )
-
-          ENDDO
-
-          DO  k = nzb_max_l+1, nzt
-
-             u_comp            = u(k,j,i) + u(k,j,i-1) - gu
-             swap_flux_x_local_u(k,j) = u_comp * (                             &
-                             37.0_wp * ( u(k,j,i) + u(k,j,i-1)   )             &
-                           -  8.0_wp * ( u(k,j,i+1) + u(k,j,i-2) )             &
-                           +           ( u(k,j,i+2) + u(k,j,i-3) ) ) * adv_mom_5
-             swap_diss_x_local_u(k,j) = - ABS(u_comp) * (                      &
-                             10.0_wp * ( u(k,j,i) - u(k,j,i-1)   )             &
-                           -  5.0_wp * ( u(k,j,i+1) - u(k,j,i-2) )             &
-                           +           ( u(k,j,i+2) - u(k,j,i-3) ) ) * adv_mom_5
-
-          ENDDO
-       ENDDO
-#endif
 
        !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, gu, gv) &
@@ -4694,7 +4570,8 @@
        !$ACC PRIVATE(ibit3_s, ibit4_s, ibit5_s) &
        !$ACC PRIVATE(ibit6, ibit7, ibit8) &
-       !$ACC PRIVATE(flux_r, diss_r, flux_l, diss_l) &
-       !$ACC PRIVATE(flux_n, diss_n, flux_s, diss_s) &
+       !$ACC PRIVATE(flux_r, diss_r) &
+       !$ACC PRIVATE(flux_n, diss_n) &
        !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
+       !$ACC PRIVATE(flux_l_u, diss_l_u, flux_s_u, diss_s_u) &
        !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s, w_comp) &
        !$ACC PRESENT(advc_flags_m) &
@@ -4702,73 +4579,144 @@
        !$ACC PRESENT(drho_air, rho_air_zw, ddzw) &
        !$ACC PRESENT(tend) &
-       !$ACC PRESENT(hom(nzb+1:nzb_max_l,1,1:3,0)) &
+       !$ACC PRESENT(hom(:,1,1:3,0)) &
        !$ACC PRESENT(weight_substep(intermediate_timestep_count)) &
        !$ACC PRESENT(sums_us2_ws_l, sums_wsus_ws_l)
-       DO i = nxlu, nxr
+       DO  i = nxlu, nxr
+
+          DO  j = nys, nyn
+!
+!--          Used local modified copy of nzb_max (used to degrade order of
+!--          discretization) at non-cyclic boundaries. Modify only at relevant points
+!--          instead of the entire subdomain. This should lead to better
+!--          load balance between boundary and non-boundary PEs.
+             IF( ( bc_dirichlet_l  .OR.  bc_radiation_l )  .AND.  i <= nxl + 2  .OR. &
+                 ( bc_dirichlet_r  .OR.  bc_radiation_r )  .AND.  i >= nxr - 2  .OR. &
+                 ( bc_dirichlet_s  .OR.  bc_radiation_s )  .AND.  j <= nys + 2  .OR. &
+                 ( bc_dirichlet_n  .OR.  bc_radiation_n )  .AND.  j >= nyn - 2 )  THEN
+                nzb_max_l = nzt
+             ELSE
+                nzb_max_l = nzb_max
+             END IF
 #ifndef _OPENACC
-!       
-!--       The following loop computes the fluxes for the south boundary points
-          j = nys
-          DO  k = nzb+1, nzb_max_l
-
-             ibit5 = REAL( IBITS(advc_flags_m(k,j-1,i),5,1), KIND = wp )
-             ibit4 = REAL( IBITS(advc_flags_m(k,j-1,i),4,1), KIND = wp )
-             ibit3 = REAL( IBITS(advc_flags_m(k,j-1,i),3,1), KIND = wp )
-
-             v_comp                 = v(k,j,i) + v(k,j,i-1) - gv
-             swap_flux_y_local_u(k) = v_comp * (                               &
-                                   ( 37.0_wp * ibit5 * adv_mom_5               &
-                                +     7.0_wp * ibit4 * adv_mom_3               &
-                                +              ibit3 * adv_mom_1               &
-                                   ) *                                         &
-                                     ( u(k,j,i)   + u(k,j-1,i) )               &
-                            -      (  8.0_wp * ibit5 * adv_mom_5               &
-                            +                  ibit4 * adv_mom_3               &
-                                   ) *                                         &
-                                     ( u(k,j+1,i) + u(k,j-2,i) )               &
-                        +      (               ibit5 * adv_mom_5               &
-                               ) *                                             &
-                                     ( u(k,j+2,i) + u(k,j-3,i) )               &
-                                               )                              
-                                                                              
-             swap_diss_y_local_u(k) = - ABS ( v_comp ) * (                     &
-                                   ( 10.0_wp * ibit5 * adv_mom_5               &
-                                +     3.0_wp * ibit4 * adv_mom_3               &
-                                +              ibit3 * adv_mom_1               &
-                                   ) *                                         &
-                                     ( u(k,j,i)   - u(k,j-1,i) )               &
-                            -      (  5.0_wp * ibit5 * adv_mom_5               &
-                                +              ibit4 * adv_mom_3               &
-                                   ) *                                         &
-                                     ( u(k,j+1,i) - u(k,j-2,i) )               &
-                            +      (           ibit5 * adv_mom_5               &
-                                   ) *                                         &
-                                     ( u(k,j+2,i) - u(k,j-3,i) )               &
-                                                         )
-
-          ENDDO
-
-          DO  k = nzb_max_l+1, nzt
-
-             v_comp                 = v(k,j,i) + v(k,j,i-1) - gv
-             swap_flux_y_local_u(k) = v_comp * (                               &
-                           37.0_wp * ( u(k,j,i)   + u(k,j-1,i) )               &
-                         -  8.0_wp * ( u(k,j+1,i) + u(k,j-2,i) )               &
-                         +           ( u(k,j+2,i) + u(k,j-3,i) ) ) * adv_mom_5
-             swap_diss_y_local_u(k) = - ABS(v_comp) * (                        &
-                           10.0_wp * ( u(k,j,i)   - u(k,j-1,i) )               &
-                         -  5.0_wp * ( u(k,j+1,i) - u(k,j-2,i) )               &
-                         +           ( u(k,j+2,i) - u(k,j-3,i) ) ) * adv_mom_5
-
-          ENDDO
+!
+!--          Compute southside fluxes for the respective boundary of PE
+             IF ( j == nys  )  THEN
+
+                DO  k = nzb+1, nzb_max_l
+
+                   ibit5 = REAL( IBITS(advc_flags_m(k,j-1,i),5,1), KIND = wp )
+                   ibit4 = REAL( IBITS(advc_flags_m(k,j-1,i),4,1), KIND = wp )
+                   ibit3 = REAL( IBITS(advc_flags_m(k,j-1,i),3,1), KIND = wp )
+
+                   v_comp_s       = v(k,j,i) + v(k,j,i-1) - gv
+                   flux_s_u(k,tn) = v_comp_s * (                               &
+                                  ( 37.0_wp * ibit5 * adv_mom_5                &
+                               +     7.0_wp * ibit4 * adv_mom_3                &
+                               +              ibit3 * adv_mom_1                &
+                                  ) *                                          &
+                                              ( u(k,j,i)   + u(k,j-1,i) )      &
+                           -      (  8.0_wp * ibit5 * adv_mom_5                &
+                               +              ibit4 * adv_mom_3                &
+                                  ) *                                          &
+                                              ( u(k,j+1,i) + u(k,j-2,i) )      &
+                           +      (           ibit5 * adv_mom_5                &
+                                  ) *                                          &
+                                              ( u(k,j+2,i) + u(k,j-3,i) )      &
+                                                )
+
+                   diss_s_u(k,tn) = - ABS ( v_comp_s ) * (                     &
+                                  ( 10.0_wp * ibit5 * adv_mom_5                &
+                               +     3.0_wp * ibit4 * adv_mom_3                &
+                               +              ibit3 * adv_mom_1                &
+                                  ) *                                          &
+                                              ( u(k,j,i)   - u(k,j-1,i) )      &
+                           -      (  5.0_wp * ibit5 * adv_mom_5                &
+                               +              ibit4 * adv_mom_3                &
+                                  ) *                                          &
+                                              ( u(k,j+1,i) - u(k,j-2,i) )      &
+                           +      (           ibit5 * adv_mom_5                &
+                                  ) *                                          &
+                                              ( u(k,j+2,i) - u(k,j-3,i) )      &
+                                                          )
+
+                ENDDO
+
+                DO  k = nzb_max_l+1, nzt
+
+                   v_comp_s       = v(k,j,i) + v(k,j,i-1) - gv
+                   flux_s_u(k,tn) = v_comp_s * (                               &
+                                 37.0_wp * ( u(k,j,i)   + u(k,j-1,i)   )       &
+                               -  8.0_wp * ( u(k,j+1,i) + u(k,j-2,i) )         &
+                               +           ( u(k,j+2,i) + u(k,j-3,i) ) ) * adv_mom_5
+                   diss_s_u(k,tn) = - ABS( v_comp_s ) * (                      &
+                                 10.0_wp * ( u(k,j,i)   - u(k,j-1,i)   )       &
+                               -  5.0_wp * ( u(k,j+1,i) - u(k,j-2,i) )         &
+                               +           ( u(k,j+2,i) - u(k,j-3,i) ) ) * adv_mom_5
+
+                ENDDO
+
+             ENDIF
+!
+!--          Compute leftside fluxes for the respective boundary of PE
+             IF ( i == nxlu )  THEN
+
+                DO  k = nzb+1, nzb_max_l
+
+                   ibit2 = REAL( IBITS(advc_flags_m(k,j,i-1),2,1), KIND = wp )
+                   ibit1 = REAL( IBITS(advc_flags_m(k,j,i-1),1,1), KIND = wp )
+                   ibit0 = REAL( IBITS(advc_flags_m(k,j,i-1),0,1), KIND = wp )
+
+                   u_comp_l         = u(k,j,i) + u(k,j,i-1) - gu
+                   flux_l_u(k,j,tn) = u_comp_l * (                             &
+                                    ( 37.0_wp * ibit2 * adv_mom_5              &
+                                 +     7.0_wp * ibit1 * adv_mom_3              &
+                                 +              ibit0 * adv_mom_1              &
+                                    ) *                                        &
+                                                ( u(k,j,i)   + u(k,j,i-1) )    &
+                             -      (  8.0_wp * ibit2 * adv_mom_5              &
+                                 +              ibit1 * adv_mom_3              &
+                                    ) *                                        &
+                                                ( u(k,j,i+1) + u(k,j,i-2) )    &
+                             +      (           ibit2 * adv_mom_5              &
+                                    ) *                                        &
+                                                ( u(k,j,i+2) + u(k,j,i-3) )    &
+                                                 )
+
+                    diss_l_u(k,j,tn) = - ABS( u_comp_l ) * (                   &
+                                    ( 10.0_wp * ibit2 * adv_mom_5              &
+                                 +     3.0_wp * ibit1 * adv_mom_3              &
+                                 +              ibit0  * adv_mom_1             &
+                                    ) *                                        &
+                                              ( u(k,j,i)   - u(k,j,i-1) )      &
+                             -      (  5.0_wp * ibit2 * adv_mom_5              &
+                                 +              ibit1 * adv_mom_3              &
+                                    ) *                                        &
+                                              ( u(k,j,i+1) - u(k,j,i-2) )      &
+                             +      (           ibit2 * adv_mom_5              &
+                                    ) *                                        &
+                                              ( u(k,j,i+2) - u(k,j,i-3) )      &
+                                                           )
+
+                ENDDO
+
+                DO  k = nzb_max_l+1, nzt
+
+                   u_comp_l         = u(k,j,i) + u(k,j,i-1) - gu
+                   flux_l_u(k,j,tn) = u_comp_l * (                             &
+                                   37.0_wp * ( u(k,j,i)   + u(k,j,i-1)   )     &
+                                 -  8.0_wp * ( u(k,j,i+1) + u(k,j,i-2) )       &
+                                 +           ( u(k,j,i+2) + u(k,j,i-3) ) ) * adv_mom_5
+                   diss_l_u(k,j,tn) = - ABS(u_comp_l) * (                      &
+                                   10.0_wp * ( u(k,j,i)   - u(k,j,i-1)   )     &
+                                 -  5.0_wp * ( u(k,j,i+1) - u(k,j,i-2) )       &
+                                 +           ( u(k,j,i+2) - u(k,j,i-3) ) ) * adv_mom_5
+
+                ENDDO
+
+             ENDIF
 #endif
 
 !
-!--       Computation of interior fluxes and tendency terms
-          DO  j = nys, nyn
-
-             flux_d    = 0.0_wp
-             diss_d    = 0.0_wp
-
+!--          Now compute the fluxes for the horizontal and parts.
              DO  k = nzb+1, nzb_max_l
 
@@ -4777,34 +4725,34 @@
                 ibit0 = REAL( IBITS(advc_flags_m(k,j,i),0,1), KIND = wp )
 
-                u_comp = u(k,j,i+1) + u(k,j,i)
-                flux_r = ( u_comp - gu ) * (                                   &
-                          ( 37.0_wp * ibit2 * adv_mom_5                        &
-                       +     7.0_wp * ibit1 * adv_mom_3                        &
-                       +              ibit0  * adv_mom_1                       &
-                          ) *                                                  &
-                                 ( u(k,j,i+1) + u(k,j,i)   )                   &
-                   -      (  8.0_wp * ibit2 * adv_mom_5                        &
-                       +              ibit1 * adv_mom_3                        &
-                          ) *                                                  &
-                                 ( u(k,j,i+2) + u(k,j,i-1) )                   &
-                   +      (           ibit2 * adv_mom_5                        &
-                          ) *                                                  &
-                                 ( u(k,j,i+3) + u(k,j,i-2) )                   &
-                                                 )                            
-                                                                              
-                diss_r = - ABS( u_comp - gu ) * (                              &
-                          ( 10.0_wp * ibit2 * adv_mom_5                        &
-                       +     3.0_wp * ibit1 * adv_mom_3                        & 
-                       +              ibit0  * adv_mom_1                       &
-                          ) *                                                  &
-                                 ( u(k,j,i+1) - u(k,j,i)  )                    &
-                   -      (  5.0_wp * ibit2 * adv_mom_5                        &
-                       +              ibit1 * adv_mom_3                        &
-                          ) *                                                  &
-                                 ( u(k,j,i+2) - u(k,j,i-1) )                   &
-                   +      (           ibit2 * adv_mom_5                        &
-                          ) *                                                  &
-                                 ( u(k,j,i+3) - u(k,j,i-2) )                   &
-                                                     )
+                u_comp(k) = u(k,j,i+1) + u(k,j,i)
+                flux_r(k) = ( u_comp(k) - gu ) * (                             &
+                           ( 37.0_wp * ibit2 * adv_mom_5                       &
+                        +     7.0_wp * ibit1 * adv_mom_3                       &
+                        +              ibit0 * adv_mom_1                       &
+                           ) *                                                 &
+                                          ( u(k,j,i+1) + u(k,j,i)   )          &
+                    -      (  8.0_wp * ibit2 * adv_mom_5                       &
+                        +              ibit1 * adv_mom_3                       &
+                           ) *                                                 &
+                                          ( u(k,j,i+2) + u(k,j,i-1) )          &
+                    +      (           ibit2 * adv_mom_5                       &
+                           ) *                                                 &
+                                          ( u(k,j,i+3) + u(k,j,i-2) )          &
+                                                 )
+
+                diss_r(k) = - ABS( u_comp(k) - gu ) * (                        &
+                           ( 10.0_wp * ibit2 * adv_mom_5                       &
+                        +     3.0_wp * ibit1 * adv_mom_3                       &
+                        +              ibit0 * adv_mom_1                       &
+                           ) *                                                 &
+                                          ( u(k,j,i+1) - u(k,j,i)   )          &
+                    -      (  5.0_wp * ibit2 * adv_mom_5                       &
+                        +              ibit1 * adv_mom_3                       &
+                           ) *                                                 &
+                                          ( u(k,j,i+2) - u(k,j,i-1) )          &
+                    +      (           ibit2 * adv_mom_5                       &
+                           ) *                                                 &
+                                          ( u(k,j,i+3) - u(k,j,i-2) )          &
+                                                      )
 
 #ifdef _OPENACC
@@ -4815,9 +4763,9 @@
                 ibit0_l = REAL( IBITS(advc_flags_m(k,j,i-1),0,1), KIND = wp )
 
-                u_comp_l = u(k,j,i) + u(k,j,i-1) - gu
-                flux_l   = u_comp_l * (                                        &
+                u_comp_l           = u(k,j,i) + u(k,j,i-1) - gu
+                flux_l_u(k,j,tn)   = u_comp_l * (                              &
                                        ( 37.0_wp * ibit2_l * adv_mom_5         &
                                     +     7.0_wp * ibit1_l * adv_mom_3         &
-                                    +              ibit0_l  * adv_mom_1        &
+                                    +              ibit0_l * adv_mom_1         &
                                        ) *                                     &
                                      ( u(k,j,i)   + u(k,j,i-1) )               &
@@ -4829,7 +4777,7 @@
                                        ) *                                     &
                                      ( u(k,j,i+2) + u(k,j,i-3) )               &
-                                                   )
-
-                diss_l   = - ABS( u_comp_l ) * (                               &
+                                                )
+
+                diss_l_u(k,j,tn)   = - ABS( u_comp_l ) * (                     &
                                        ( 10.0_wp * ibit2_l * adv_mom_5         &
                                     +     3.0_wp * ibit1_l * adv_mom_3         &
@@ -4844,9 +4792,7 @@
                                        ) *                                     &
                                      ( u(k,j,i+2) - u(k,j,i-3) )               &
-                                                             )
-#else
-                flux_l = swap_flux_x_local_u(k,j)
-                diss_l = swap_diss_x_local_u(k,j)
+                                                         )
 #endif
+
 
                 ibit5 = REAL( IBITS(advc_flags_m(k,j,i),5,1), KIND = wp )
